Subject: Re: [PATCH v2] bonding: send IPv6 neighbor advertisement on failover

From: Vlad Yasevich <[email-masked]>
Date: Fri, 10 Oct 2008 12:29:06 -0400

Brian Haley wrote:
> Jay Vosburgh wrote:
>>     As a semi-related question, what does IPv6 do if it receives a
>> gratutitous NA, and finds a duplicate?
> 
> If a node has an IPv6 neighbor entry and receives an unsolicited NA it
> will change it's state to stale, forcing a re-lookup on the next
> transmit.  An un-solicited NA will change the state to reachable.
                ^^^^^^^^^^^^

You probably meant to say "solicited".  Unsolicited NAs can only change
the state to STALE.

Also, the re-lookup will happen on a delay after the transmit.

-vlad

> 
>>     I agree that doing DAD would update the switches, peers, etc,
>> but, if I'm reading the IPv6 code correctly, the delay between probes is
>> one second (nd_tbl.retrans_time), and it looks like there's an initial
>> delay of up to 1 second as well (in addrconf_dad_kick, the
>> rtr_solicit_delay).  For failover purposes, we want to issue the
>> gratuitous ARP or NA packets immediately with a minimal delay between
>> probes.
> 
> Right, and since a bond failover event should be rare, I think sending
> the NA immediately is OK.  All those random delays are meant to cover
> the case, for example, when a router sends an advertisement with a new
> prefix - you don't want everyone that receives it to do DAD immediately
> since it could overwhelm the network.
> 
> -Brian
> -- 
> To unsubscribe from this list: send the line "unsubscribe netdev" in
> the body of a message to [email-masked]
> More majordomo info at  http://vger.kernel.org/majordomo-info.html
>